module arith;

 { module icomplex; }


use global i_ari; 

	  
global type icom =  global record
		re	 : interval;
		im	 : real;
end;			 

global function im(x :icom):real;
begin
   im:=x.im;
end; { compl }

global function re(x :icom):interval;
begin
   re:=x.re;
end; { compl }

global function icompl(r : interval; i:real):icom;
begin
   icompl.re:=r;
   icompl.im:=i;
end; { icompl }

global function icompl(r : interval):icom;
begin
   icompl.re:=r;
   icompl.im:=0;
end; { icompl }

global function diam(r : icom):real;
begin
   diam:=sqrt(sup(sqr(r.re)) +> r.im*>r.im);
end; { icompl }

global function icompl(r1 : real; r2 : real; i:real):icom;
begin
   icompl.re:=intval(r1,r2);
   icompl.im:=i;
end; { icompl }

global operator - ( x : icom) minus : icom;
begin
   minus.re:=-x.re;
   minus.im:=x.im;
end;




{---------------- Addition -------------------}

{global operator +  ( x,y : icom) add : icom;
begin
   add.re.sup:=x.re.sup+>y.re.sup;
   add.im:=x.im+>y.im;
   add.re.inf:=x.re.inf+<y.re.inf;
end;}

global operator +  ( x,y : icom) add : icom;
begin
   add.re:=x.re+y.re;
   add.im:=x.im+>y.im;
end;

global operator +  ( x:interval; y : icom) add : icom;
var hilf : real ; 
begin
   add.re:=x+y.re;
   add.im:= y.im;
end;

global operator +  (y : icom; x:interval) add : icom;
var hilf : real ; 
begin
   add.re:=x+y.re;
   add.im:= y.im;
end;

global operator + (y:icom; x:real) add:icom;
begin
   add:= y+intval(x);
end;

operator + (x:real; y:icom) add:icom;
begin
   add:= y+intval(x);
end;

global operator + (y:icom; x:integer) add:icom;
begin
   add:= y+intval(x);
end;

global operator + (x:integer; y:icom) add:icom;
begin
   add:= y+intval(x);
end;

{---------------- Subtraktion -------------------}

global operator -  ( x,y : icom) sub : icom;
begin
   sub.re.sup:=x.re.sup->y.re.inf;
   sub.im:=x.im+>y.im;
   sub.re.inf:=x.re.inf-<y.re.sup;
end;

global operator -  ( x:interval; y : icom) sub : icom;
var hilf : real ; 
begin
   sub.re:=x-y.re;
   sub.im:= y.im;
end;

global operator -  (y : icom; x:interval) sub : icom;
var hilf : real ; 
begin
   sub.re:=y.re-x;
   sub.im:= y.im;
end;

global operator - (y:icom; x:real) sub:icom;
begin
   sub:= y-intval(x);
end;

global operator - (x:real; y:icom) sub:icom;
begin
   sub:= y-intval(x);
end;

global operator - (y:icom; x:integer) sub:icom;
begin
   sub:= y-intval(x);
end;

global operator - (x:integer; y:icom) sub:icom;
begin
   sub:= y-intval(x);
end;

{---------------- Multiplikation -------------------}

global operator *  ( x,y : icom) mul : icom;
var hilf : real ; 
begin
   hilf:=x.im*>y.im;
   mul.im:= sup(abs(x.re))*>y.im +>  sup(abs(y.re))*>x.im;
   mul.re:=x.re*y.re+intval(-hilf,hilf);
end;

global operator *  ( x:interval; y : icom) mul : icom;
var hilf : real ; 
begin
   mul.re:=x*y.re;
   mul.im:= sup(abs(x))*>y.im;
end;

global operator *  (y : icom;  x:interval) mul : icom;
var hilf : real ; 
begin
   mul.re:=x*y.re;
   mul.im:= sup(abs(x))*>y.im;
end;

global operator * (y:icom; x:real) mul:icom;
begin
   mul:= y*intval(x);
end;

global operator * (x:real; y:icom) mul:icom;
begin
   mul:= y*intval(x);
end;

global operator * (y:icom; x:integer) mul:icom;
begin
   mul:= y*intval(x);
end;

global operator * (x:integer; y:icom) mul:icom;
begin
   mul:= y*intval(x);
end;


{---------------- Division -------------------}

global operator /  ( x,y : icom) divi : icom;
var h1 : interval ;
h2     :icom;
begin
   h1:=1/(sqr(y.re)+intval(0,y.im*>y.im));
   h2:=x*y;
   divi.re:=h1*h2.re;
   divi.im:=sup(abs(h1))*>h2.im;
end;

global operator /  ( x :interval ; y : icom) divi : icom;
var h1 : interval ;
h2     :icom;
begin
   h1:=1/(sqr(y.re)+intval(0,y.im*>y.im));
   h2:=x*y;
   divi.re:=h1*h2.re;
   divi.im:=sup(abs(h1))*>h2.im;
end;

global operator /  ( y : icom;  x :interval ) divi : icom;
begin
   divi.re:=y.re/x;
   divi.im:=y.im/>inf(abs(x));
end;


global operator / (y:icom; x:real) divi:icom;
begin
   divi:= y/intval(x);
end;

global operator / (x:real; y:icom) divi:icom;
begin
   divi:= intval(x)/y;
end;

global operator / (y:icom; x:integer) divi:icom;
begin
   divi:= y/intval(x);
end;

global operator / (x:integer; y:icom) divi:icom;
begin
   divi:= intval(x)/y;
end;



{------------ Exp ------------------}

global function exp(x : icom):icom;
const ed20 = 0.0500000001;
   ed6	   = 0.166666666;
   ed30	   = 0.033333334;
   ed12	   = 0.083333333;
   edo12   = 0.083333334;

var ex		  : interval;
   sq, hx, si, co : real;
begin
   if (x.im<3.14) then
   begin
      ex:=exp(x.re);
      if (x.im<1.57) then
      begin
	 sq:=x.im*>x.im;
	 si:=x.im*>(1->sq*<ed6*<(1-<sq*>ed20));
	 co:=1-<0.5*>sq*>(1->sq*<ed12*<(1-<sq*>ed30));
	 exp.re:=intval(co*<inf(ex), sup(ex));
	 exp.im:=sup(ex)*>si;
      end
      else
      begin
	 exp.im:=sup(ex);
	 hx:=3.14-x.im;
	 co:=1->0.5*<sq*>(1-<sq*>edo12);
	 exp.re:=intval(co*<sup(ex), sup(ex));
      end;
   end
   else
   begin
      hx:=exp(sup(x.re))*1.000000001;
      exp.re:=intval(-hx,hx);
      exp.im:=hx;
   end;
end;

{------------ Sqrt ------------------}


global function sqrt(x : icom):icom;
var sqim : real;
begin
   sqim:=x.im*>x.im;
   sqrt.im:=1.000000001*sqrt(0.5
			     *(sqrt(inf(x.re)*>inf(x.re)+>sqim)->inf(x.re)));
   sqrt.re:=intval(0.9999999999*sqrt(inf(x.re)),1.000000001*
		   sqrt(0.5*(sqrt(sup(x.re)*>sup(x.re)+>sqim)+>sup(x.re)))); 

   
end; 

{------------ Sin ------------------}

global function sin(x : icom):icom;
var ex,edex  : real;
begin
   ex:=1.0000001*exp(x.im);
   edex:=1/ex;
   sin.re:=intval(1, 0.5*(ex+edex))*sin(x.re);
   sin.im:=0.5*(ex-edex)*sup(abs(cos(x.re)));
end;

{------------ Cos ------------------}

global function cos(x : icom):icom;
var ex,edex  : real;
begin
   ex:=1.0000001*exp(x.im);
   edex:=1/ex;
   cos.re:=intval(1, 0.5*(ex+edex))*cos(x.re);
   cos.im:=0.5*(ex-edex)*sup(abs(sin(x.re)));
end;

{------------ Tan -----------------}

global function tan(x : icom):icom;
var ex,edex : real;
   nenner  : interval;
begin
   ex:=1.0000001*exp(2*x.im);
   edex:=1/ex;
  
   nenner:=1/(intval(2.0, ex+>edex)+2*cos(2*x.re));
   tan.re:=2*sin(2*x.re)*nenner;
   tan.im:=(ex->edex)*>inf(nenner);
end;

{------------ Sqr ------------------}

global function sqr(x : icom):icom;
begin
   sqr.re:=sqr(x.re)-intval(0.0, x.im*>x.im);
   sqr.im:=2*sup(abs(x.re))*>x.im;
end;

{------------ Abs ------------------}

global function abs(x : icom):interval;
begin
   abs:=sqrt(sqr(x.re)+sqr(intval(0,x.im)));
end;

{------------ Ln ------------------}

global function ln(x : icom):icom;
var ex,edex  : real;
begin
   ln.im:=1.000000001*arctan(x.im/>inf(abs(x.re)));
   ln.re:=0.5*ln(intval(inf(x.re)*<inf(x.re),sup(x.re)*>sup(x.re)
	     +x.im*>x.im));
end;
end.


{   
var a,b,c : icom;
   x,y,z  : cinterval;
   i,j	  : integer;
begin
   a.re := intval(1.05,1.11);
   a.im := sup(intval(0.2));
   b.re := intval(0.97, 0.98);
   b.im := sup(intval(0.01));
   c:=a;
   x:=icompl(a.re, intval(-a.im, a.im));
   y:=icompl(b.re, intval(-b.im, b.im));
   z:=x;
 writeln(inf(x.re),',', sup(x.re),',', sup(x.im));

   
   for i:=1 to 1000 do
   begin
      for j:=1 to 100 do
      begin
	 a:=sqrt(c); 
 x:=cos(z);  
      end;
   end; 


   

   
 writeln(inf(x.re),',', sup(x.re),',', sup(x.im));
   writeln(inf(a.re),',', sup(a.re),',',  a.im);


   

end.
}





