module  cinte;

use global bi_ari, ade_ari,
g_form, timer; 


{ ===== TYPDEFINITION =========}

{ ===== Listenelement fuer Ausnahmeintervalle ===========}
type pt	 = ^blist;
   blist = record
	      basic : interval; 
	      next  : pt; 
	   end;	    


var nges : integer;



{ ===== HILFSROUTINEN =========}


{=======  Vorzeitiger Abbruch        ===================================}

procedure abbruch;
begin
   writeln('The required precision cannot be attained');
   writeln('before the maximal number of subdivisions is reached. '); 
   writeln(' Please enter Ctrl-C ');
end; { abbruch }


{==== Auswahl einer passenden Gauss-Formel  =============}

procedure choice (var n,nn : integer );
begin
   if (n<39) then
   begin
      if (n<12) then
      begin
	 if (n<5) then
	 begin
	    if (n<2) then		  
	    begin   nn:=1;  n:=2  end
	    else
	    begin  nn:=2;  n:=4 end
	 end
	 else
	 begin
	    if (n<8) then begin nn:=3; n:=7  end
	    else
	    begin nn:=4;  n:=11    end
	 end
      end
      else {=========   n>=12   ================}
      begin
	 if (n<23) then
	 begin
	    if (n<17) then		  
	    begin  nn:=5; n:=16 end
	    else
	    begin nn:=6; n:=22  end
	 end
	 else
	 begin
	    if (n<30) then		  
	    begin  nn:=7;  n:=29   end
	    else
	    begin  nn:=8;  n:=38 end
	 end
      end
   end
   else  {=========   n>=39   ================}
   begin
      if (n<81) then
      begin
	 if (n<58) then
	 begin
	    if (n<48) then		  
	    begin nn:=9; n:=47  end
	    else
	    begin nn:=10;  n:=57 end
	 end
	 else
	 begin
	    if (n<69) then		  
	    begin nn:=11; n:=68  end
	    else
	    begin  nn:=12;  n:=80  end
	 end
      end
      else {=========   n>=81   ================}
      begin
	 if (n<109) then
	 begin
	    if (n<94) then		  
	    begin nn:=13;  n:=93 end
	    else
	    begin  nn:=14; n:=108 end
	 end
	 else
	 begin  nn:=15;   n:=128  end
      end
   end;
end; { choice }







{ ===== INTEGRATIONSPROGRAMM :   ========================}   
{ ===== Eingaben sind:           ========================}
{ ===== -- reelle Funktion (fuer ========================}   
{ =====    Funktionsauswertungen an den x_nu),===========}   
{ ===== -- Funktion, mit der Beschraenktheit ============}   
{ =====    festgestellt werden soll =====================}   
{ ===== -- Funktion mit allen Informationen  ============}   
{ ===== -- beide Intervallgrenzen            ============}   
{ ===== -- Grenze fuer die Intervallbreite   ============}   
{ =====    Unterhalb der nicht mehr auf  Beschraenkt - ==}   
{ =====    heit getestet werden soll  ===================}   

GLOBAL FUNCTION INTEGRATE(function f(x	: interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
		   a,b, eps,except:real): interval;



var r,zlnr, rr, maxmin, eps0, errconst, gesamtb, berg : real;
   x, errb, ergebnis				      : interval;
   n, nodes, i, j				      : integer; 
   erg						      : analyticd;
   y,z						      : cinterval; 
   pos_list, neg_list				      : pt;


{=======  Abschaetzung der Bandbreite von f auf Teilintervallen ========}
{======  Parameter: Zur Verfuegung stellen von Funktionen ==============}
function estdiam(function fb(xx : interval):b_interval;
		 a     : interval;
		 depth : integer) : real; 

var mitte, elinks, erechts, h : real;
   i1, i2		      : interval;
   links, rechts	      : b_interval; 
   e1,e2		      : integer; 
{========== Anhaengen eines Listenelements an ein pt ==========}
procedure append(    a	   : interval; 
		 var liste : pt);
var h : pt; 
begin
   new(h);
   h^.basic := a;
   h^.next := liste;
   liste := h;
end; { append }

begin {estdiam}
   mitte:= mid(a);
   i1:= intval(inf(a), mitte); 
   i2:= intval( mitte, sup(a));   
   links  :=fb(i1);
   rechts := fb(i2);
{=== Unerreichbare Genauigkeit herabsetzen  ===============}
   if (links.b) then eps:=max(eps, diam(i1)*
			      eps0/100*inf(abs(links.int))); 
   if (rechts.b) then eps:=max(eps, diam(i2)
			       *eps0/100*inf(abs(rechts.int))); 
   if (depth=0) then
   begin  { = Oft genug unterteilt = }
      estdiam := max(diam(links.int), diam(rechts.int));
      append(i1, pos_list);
      append(i2, pos_list);
   end
   else
      if (diam(i1) < except) then
      begin {= Zu kleiner Intervalldurchmesser ohne Beschraenktheit =}
	 if links.b then
	    append(i1, pos_list)
	 else
	 begin
	    append(i1, neg_list);
	    links.int:=0;
	 end;
	 if rechts.b then
	    append(i2, pos_list)
	 else
	 begin
	    append(i2, neg_list);
	    rechts.int:=0;
	 end;
	 estdiam:=max(diam(links.int),diam(rechts.int) );
      end
      else
	 begin {===  weitere Unterteilung ========}
	    e1:=links.b;
	    e2:=rechts.b; 
	    elinks := estdiam(fb,i1, depth-e1);
	    erechts:= estdiam(fb,i2, depth-e2);
	    estdiam := max(elinks, erechts);
	 end;
end; { estdiam }
   

{=======  Erzeugung unterschiedlicher Listen von Teilintervallen ========}

function quad(function f(x : interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
	      aint : interval;
	      c : real;
	      count : integer ):interval; 

var mitte, sing, li		  : real;
   i1,  zwerg, i2, dn		  : interval;
   links, rechts, elinks, erechts : analyticd; 
   e1,e2, nn, nu		  : integer; 
   hilflist			  : pt;
   rpot				  : array[1..128] of interval; 
			  
 


procedure subdivide(function f(x	: interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
b : interval);
var erg				    : analyticd;
   sub				    : boolean;
   db, mitte,h, hilf,d1, d2, diamet : real ;
   mitt, d, di2, dn		    : interval;
   nu, nn			    : integer;
begin			    
   rerror:=false; 
   sub:=true;   
   erg:= fa(b,r);
   db:=diam(b);
   if (rerror) then
   begin
      count:=count -1;
      if (count<0) then abbruch; 
      mitte:= mid(b);
      subdivide(f,fb,fa,intval(inf(b), mitte));
      subdivide(f,fb,fa, intval( mitte, sup(b))); 
   end
   else
   begin
      eps:=max(eps, eps0/100*db*inf(abs(erg.rint)));  
      if (erg.a) then
      begin { = Analytizitaet festgestellt = }
	 h:=errconst/(2*rr)*dia(erg.cint);
	 if (h*gesamtb <eps) then { = moeglicher Fehler klein genug = }
	 begin 
	    d:=(intval(sup(b))-intval(inf(b)))/2;
	    diamet:=succ(dia(erg.cint));
	    mitt:=intval(0.5)*sup(b)+intval(0.5)*inf(b);
	    n:=round((0.5+ln(0.25*errconst/eps*diamet*gesamtb)/zlnr)); 
	    
	    {===== Auswahl einer moeglichen Stuetzstellenzahl =====}
	    choice (n, nn);
	    zwerg:=0;
      { === Anwendung der Quadraturformel === }
	    for nu:=1 to n do
	       zwerg:=zwerg + anu[nn]^[nu]* f(mitt+d*xnu[nn]^[nu]);
	    ergebnis:=ergebnis+d*zwerg;
	    errb:=errb + 0.25*errconst*diamet*d/rpot[n];
	    sub:=false;
	 end;
      end;
      if (erg.d and sub) then  {= Funktion nicht analytisch aber dfb. = }
	 if (db * diam(erg.dint)*gesamtb <2000*eps) then
	 begin {= Die Quadratur auf dem Teilintervall kann stattfinden =}
	    diamet:=succ(diam(erg.dint));
	    d:=(intval(sup(b))-intval(inf(b)))/2;
	    li:=inf(b);
	    n:=min(round(sup(0.5+d*gesamtb/eps/8*diamet)), 10000);
	    dn:=d/n;
	    di2:=d/2;
	    zwerg:=0;
	    for nu:=1 to n do
	       zwerg:=zwerg+ f(li +(2*nu-1)*di2); 
	    ergebnis:=ergebnis+d*zwerg;
	    errb:=errb + diamet*0.125*dn*d;
	    sub:=false;
	 end;
      if (((db < 1.0e-14*(abs(inf(b))+abs(sup(b))))
	  or (diam(erg.rint)*gesamtb < eps)) and sub) then
      begin { = Funktion beschraenkt und Intervallbreite klein = }
	 hilf:=mid(erg.rint);
	 ergebnis:=ergebnis + db * hilf; 
	 d1 := succ(db)-db; 
	 d2 := succ(hilf)-hilf; 
	 errb := errb + d1 * hilf + d2 * db + d1*d2; 
	 sub:=false;
      end;
      if (sub) then
      begin { = Noch keine hinreichende Information => Unterteilung =}
	 count:=count -1;
	 if (count<0) then abbruch; 
	 mitte:= mid(b);
	 subdivide(f,fb,fa,intval(inf(b), mitte)); 
	 subdivide(f,fb,fa,intval( mitte, sup(b)));
      end;
   end;
end; { subdivide }
   
begin { gen_list }     {Warnung im C-Compiler}
   li:= sqr(r);
   rpot[1]:=li;
   for nu:=2 to 128 do
      rpot[nu] := li*rpot[nu-1]; 

   { ===== Initialisierungsphase ====================}
   if (neg_list <> nil) then
   begin
      writeln('Integration over ', intval(a,b), ' with exception interval(s)');
   end;
   {====== Ausgabe der Ausnahmeintervalle ==========}
   while (neg_list <> nil) do
   begin
      hilflist:=neg_list^.next;
      writeln('[', inf(neg_list^.basic):25,' , ',sup(neg_list^.basic):25, ']');
      dispose(neg_list);
      neg_list:=hilflist;
   end;
   while (pos_list <> nil) do
   begin {= Abarbeitung der Teilintervalle =======}
      aint:= pos_list^.basic;
{ ===== Rekursionsaufruf zur Erzeugung einer Intervall-Liste =========}   
      gesamtb:= diam(aint); 
      subdivide (f,fb,fa,aint);
      hilflist:=pos_list^.next;
      dispose(pos_list);
      pos_list:=hilflist;
   end;
   quad:=ergebnis;
end; { quad }
   
{ ===== Listenausgabe    =========================}   

procedure writelist(liste : pt);
var h : pt; 
begin
   new(h);
   h:= liste;
   while (h<>nil) do 
   begin
      writeln (h^.basic);
      h:=h^.next;
   end;
end; 



begin {main}
   r:=4.0; {In dieser Version wird ein Rechteckparameter vorgegeben } 
   rr:=sqr(r);
   eps0:=eps; 	 	   
   errb := 0; 
   ergebnis:=0;

   {  ===== Konstanter Teil der Fehlerkonstante der Gauss-Formel :  =====  }
   errconst:= 3.142*(1+1/(rr+sqr(rr)))*(1+0.75/rr + 4.5/(rr*r)); 

   {  ===== Minimal erreichbare Fehlerordnung mit 128 Stuetzstellen =====  }
   for n:=2 to 8 do
      rr:=rr*rr; 
   zlnr:=2*ln(r); 

   { =====  Quadraturformeln einlesen  =====  }
  
 
   
   x := intval (a, b); 
   pos_list:=nil;
   neg_list:=nil;
   {  ===== Durchmesser des reellen Wertebereichs  ===== }
   berg := estdiam(fb,x,2);

   { ===== Intervall-Aufteilung =======} 
   { ===== Quadraturformel aufstellen  =======} 
   { ===== Quadraturformel anwenden =======}
   integrate:=quad(f, fb, fa, x, 2.0, 10000)+ intval(-1,1)*errb ; 

end; { integrate}


GLOBAL FUNCTION INTEGRATE(function f(x : interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
			  a,b, eps,except:real; n:integer): interval;

begin
   integrate:=integrate(f,fb,fa,a,b,eps, except);
   n:=nges;
end; { integrate }










{ ===== INTEGRATIONSPROGRAMM :   ========================}   
{ ===== Eingaben sind:           ========================}
{ ===== -- reelle Funktion (fuer ========================}   
{ =====    Funktionsauswertungen an den x_nu),===========}   
{ ===== -- Funktion, mit der Beschraenktheit ============}   
{ =====    festgestellt werden soll =====================}   
{ ===== -- Funktion mit allen Informationen  ============}   
{ ===== -- beide Intervallgrenzen            ============}   


GLOBAL FUNCTION INTEGRATE(function f(x	: interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
		   a,b, eps:real): interval;



var r,zlnr, rr, maxmin, eps0, errconst, gesamtb	: real;
   x, errb, ergebnis				: interval;
   n, nodes, i, j, lauf				: integer; 
   erg						: analyticd;
   berg						: b_interval; 
   y,z						: cinterval; 

{=======  Abschaetzung der Bandbreite von f auf Teilintervallen ========}




function estdiam(function fb(xx	: interval):b_interval;
		 a : interval;
		 depth, maxdepth : integer) : b_interval; 

var mitte , h			  : real;
   i1, i2			  : interval;
   links, rechts, elinks, erechts : b_interval; 
   e1,e2			  : integer; 
begin
   mitte:= mid(a);
   i1:= intval(inf(a), mitte); 
   i2:= intval( mitte, sup(a));   
   links  :=fb(i1);
   rechts := fb(i2);

   {=== Unerreichbare Genauigkeit herabsetzen  ===============}
   if (links.b) then eps:=max(eps,
			      diam(i1)*eps0/100*inf(abs(links.int))); 
   if (rechts.b) then eps:=max(eps, diam(i2)*
			       eps0/100*inf(abs(rechts.int))); 
   if (depth=0) then
   begin { = Oft genug unterteilt = }
      mitte := max(diam(links.int), diam(rechts.int));
      estdiam.int:= mitte; 
      estdiam.b   := true;
   end
   else
      if (maxdepth < depth) then
      begin {===  Maximale Rekursionstiefe erreicht ========}
	 estdiam.int:=0;
	 estdiam.b  :=false;
      end
      else
	 begin {===  weitere Unterteilung ========}
	    e1:=links.b;
	    e2:=rechts.b; 
	    elinks := estdiam(fb,i1, depth-e1, maxdepth-1);
	    erechts:= estdiam(fb,i2, depth-e2, maxdepth-1);
	    estdiam.int := max(sup(elinks.int), sup(erechts.int));
	    estdiam.b   := elinks.b and erechts.b; 
	 end;
end;

{=======  Erzeugung unterschiedlicher Listen von Teilintervallen ========}

function quad(function f(x : interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
	      a  :  interval;
	      c : real;
	      count      : integer ): interval; 

var mitte, sing, li		  : real;
   i1, i2, zwerg, dn		  : interval;
   links, rechts, elinks, erechts : analyticd; 
   e1,e2, nn, nu		  : integer; 
   rpot				  : array[1..128] of interval; 
				  
   

procedure subdivide(function f(x	: interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
b : interval);
var erg				    : analyticd;
   sub				    : boolean;
   db, mitte,h, hilf,d1, d2, diamet : real;
   mitt, d, di2, dn		    : interval;
   nu, nn			    : integer;
				    
begin
   rerror:=false; 
   sub:=true; 
   erg:= fa(b,r);
   
   db:=diam(b);
   if (rerror) then
   begin
      count:=count -1;
      if (count<0) then abbruch; 
      mitte:= mid(b);
      subdivide(f,fb,fa,intval(inf(b), mitte));
      subdivide(f,fb,fa, intval( mitte, sup(b))); 
   end
   else
   begin
      eps:=max(eps, db*eps0/100*inf(abs(erg.rint)));  
      if (erg.a) then { = Analytizitaet festgestellt = }
      begin
	 h:=errconst/(2*rr)*dia(erg.cint);
	 if (h*gesamtb <eps) then { = moeglicher Fehler klein genug = }
	 begin
	    d:=(intval(sup(b))-intval(inf(b)))/2;
	    diamet:=succ(dia(erg.cint));
	    mitt:=intval(0.5)*sup(b)+intval(0.5)*inf(b);
	    n:=round((0.5+ln(0.25*errconst/eps*diamet*gesamtb)/zlnr)); 
	    
	    {===== Auswahl einer moeglichen Stuetzstellenzahl =====}
	    choice (n, nn);
	    nges:=nges+n;
	    zwerg:=0;
      { === Anwendung der Quadraturformel === }
	    for nu:=1 to n do
	       zwerg:=zwerg + anu[nn]^[nu]* f(mitt+d*xnu[nn]^[nu]);
	    ergebnis:=ergebnis+d*zwerg;
	    errb:=errb + 0.25*errconst*diamet*d/rpot[n];
	    sub:=false;
	 end;
      end;
      if (erg.d and sub) then {= Funktion nicht analytisch aber dfb. = }
	 if (db * diam(erg.dint)*gesamtb <2000*eps) then
	 begin
	    diamet:=succ(diam(erg.dint));
	    d:=(intval(sup(b))-intval(inf(b)))/2;
	    li:=inf(b);
	    n:=min(round(sup(0.5+d*gesamtb/eps/8*diamet)), 10000);
	    nges:=nges+n;
	    dn:=d/n;
	    di2:=d/2;
	    zwerg:=0;
	    for nu:=1 to n do
	       zwerg:=zwerg+ f(li +(2*nu-1)*di2); 
	    ergebnis:=ergebnis+d*zwerg;
	    errb:=errb + diamet*0.125*dn*d;
	    sub:=false;
	 end;
      if (((db < 1.0e-14*(abs(inf(b))+abs(sup(b))))
	  or (diam(erg.rint)*gesamtb < eps)) and sub) then
      begin
	 hilf:=mid(erg.rint);
	 ergebnis:=ergebnis + db * hilf; 
	 d1 := succ(db)-db; 
         d2 := succ(hilf)-hilf; 
	 errb := errb + d1 * hilf + d2 * db + d1*d2; 
	 sub:=false;
      end;
      if (sub) then
      begin { = Noch keine hinreichende Information => Unterteilung =}
	 count:=count -1;
	 if (count<0) then abbruch; 
	 mitte:= mid(b);
	 subdivide(f,fb,fa,intval(inf(b), mitte)); 
	 subdivide(f,fb,fa,intval( mitte, sup(b)));
      end;
   end;
end; { subdivide }
   
begin { quad }
   li:= sqr(r);
   rpot[1]:=li;
   for nu:=2 to 128 do
      rpot[nu] := li*rpot[nu-1]; 
{ ===== Initialisierungsphase ====================}
   gesamtb:= diam(a); 
   ergebnis:=0; 		

{ ===== Rekursionsaufruf =========================}   
   subdivide (f,fb,fa,a);
   quad:=ergebnis;
end; { gen_list }
   
   


begin
   r:=4.0; {In dieser Version wird ein Rechteckparameter vorgegeben } 
   rr:=sqr(r);
   errb := 0;
   nges:=0;

   eps0:=eps; 	 	   
   {  ===== Konstanter Teil der Fehlerkonstante der Gauss-Formel :  =====  }
   errconst:= 3.142*(1+1/(rr+sqr(rr)))*(1+0.75/rr + 4.5/(rr*r)); 
   
   {  ===== Maximal erreichbare Fehlerordnung mit 128 Stuetzstellen =====  }
   for n:=2 to 8 do
      rr:=rr*rr; 
   zlnr:=2*ln(r); 
 
   { =====  Quadraturformeln einlesen  =====  }
  { q_einlesen;
   q2_einlesen;}

   x := intval (a, b); 

   writeln(lauf);
   
   {  ===== Durchmesser des reellen Wertebereichs  ===== }
   berg := estdiam(fb,x,1,70);   
   
   { ===== Intervall-Aufteilung =======} 

   if (berg.b) then
      integrate:= quad(f,fb,fa,x, 2.0, 100000)+ intval(-1,1)*errb
   else
	 writeln ('Integrand unbounded ??');


end; { integrate}



GLOBAL FUNCTION INTEGRATE(function f(x : interval): interval;
function fb(xx : interval):b_interval;
function fa(xx : interval; r:real):analyticd;
			  a,b, eps:real ; var n:integer): interval;

begin
   integrate:=integrate(f,fb,fa,a,b,eps);
   n:=nges;
end; { integrate }





global procedure cinte_init;
begin
   q_einlesen;
   q2_einlesen;
end; { cinte_init }


begin

end.
      

