
program test (input, output);

use cinte; 

var integral,z, pi   : interval;
   i,n,na,nb, nr, n2 : integer;
   bi		     : b_interval;


{=======  Definition der Integranden ===================================}

{=======  0: 1/(1+x^4) ===========================}
       
function fa0(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa0:= 1/(1+sqr(sqr(x)));
end; 
        
function fb0(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb0:=  1/(1+sqr(sqr(x)));
end; 
   
function f0(x : interval): interval; 
begin
   f0 :=  1/(1+sqr(sqr(x)));
end;

{=======  1: sin(x^2)*exp(x)  ====================}
       
function fa1(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa1:= sin(sqr(x))*exp(x);
end; 
        
function fb1(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb1:= sin(sqr(x))*exp(x);
end; 
   
function f1(x : interval): interval; 
begin
   f1 := sin(sqr(x))*exp(x);
end;

{=======  2: (3-x)*(5-x)/(4-x) ====================}
    
function fa2(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa2:=  (x-3)*(x-5)/(x-4);
end; 
     
function fb2(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb2:=(x-3)*(x-5)/(x-4);
end; 
   
function f2(x : interval): interval; 
begin
   f2 := (x-3)*(x-5)/(x-4);
end;

{=======  3: sin(e^x)  ====================}
       
function fa3(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa3:= sin(exp(x));
end; 
        
function fb3(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb3:= sin(exp(x));
end; 
   
function f3(x : interval): interval; 
begin
   f3 := sin(exp(x));
end;

{=======  4: 5 sin x + (9x-4)*(9x-8)*.../(1+(90-110x)^4  ====================}
    
function fa4(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa4:=  5*sin(x)+
   (9*x-4)*
   (9*x-8)*
   (3*x-4)*
   (9*x-10)*
   (pi-2*x)/
   (1+sqr(sqr(90*x-110)));
end; 
     
function fb4(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb4:=  5*sin(x)+
   (9*x-4)*
   (9*x-8)*
   (3*x-4)*
   (9*x-10)*
   (pi-2*x)/
   (1+sqr(sqr(90*x-110)));
end; 
   
function f4(x : interval): interval; 
begin
   f4 := 5*sin(x)+
   (9*x-4)*
   (9*x-8)*
   (3*x-4)*
   (9*x-10)*
   (pi-2*x)/
   (1+sqr(sqr(90*x-110)));
end;

{======== 5: 4sin(x)+1/4*sqrt(|x-z|^3) ==========}

function fa5(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa5:= 4*sin(x)+0.25*pow(sqrtabs(x-z),3)
end; 
     
function fb5(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb5:= 4*sin(x)+0.25*pow(sqrtabs(x-z),3)
end; 
   
function f5(x : interval): interval; 
begin
   f5 :=4*sin(x)+0.25*pow(sqrtabs(x-z),3)
end;

{=======  6: 1/(1+10x^2)  ====================}
       
function fa6(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa6:= 1/(1+10*sqr(x));
end; 
        
function fb6(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb6:=  1/(1+10*sqr(x));
end; 
   
function f6(x : interval): interval; 
begin
   f6 := 1/(1+10*sqr(x)); 
end;

{=======  7: sin(1/x)  ====================}
       
function fa7(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa7:= sin(1/x);
end; 
        
function fb7(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb7:= sin(1/x);
end; 
   
function f7(x : interval): interval; 
begin
   f7 := sin(1/x);
end;

{=======  8: exp("rational function")  ====================}
       
function fa8(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa8:= exp(-sqr(x+1)/(pow(x,4)+3*pow(x,3)+
	     6*sqr(x)+2*x+1));
end; 
        
function fb8(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb8:=  exp(-sqr(x+1)/(pow(x,4)+pow(x,3)+
	     6*sqr(x)+2*x+1));
end; 
   
function f8(x : interval): interval; 
begin
   f8 :=  exp(-sqr(x+1)/(pow(x,4)+3*pow(x,3)+
	     6*sqr(x)+2*x+1));
end;

{=======  9: 1/(e^(-x)+cos^2 x)  ====================}
       
function fa9(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa9:= 1/(exp(-x)+ sqr(cos(x)));
end; 
        
function fb9(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb9:=  1/(exp(-x)+ sqr(cos(x)));
end; 
   
function f9(x : interval): interval; 
begin
   f9 := 1/(exp(-x)+ sqr(cos(x)));
end;

{=======  10: e^(-x^2)  ====================}
       
function fa10(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   fa10:=exp(-sqr(x));
end; 
        
function fb10(xx : interval):b_interval; 
var x : b_interval;
begin
   x := construct(xx);
   fb10:= exp(-sqr(x));
end; 
   
function f10(x : interval): interval; 
begin
   f10 := exp(-sqr(x));
end;

{======== 11: 1/(1-0.55x^2) ==========}

function fa11(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   na:=na+1;
   fa11:= 1/(1-0.55*sqr(x));
end; 
     
function fb11(xx : interval):b_interval; 
var x : b_interval;
begin
   nb:=nb+1;
   x := construct(xx);
   fb11:=1/(1-0.55*sqr(x));
end; 
   
function f11(x : interval): interval; 
begin
   f11 := 1/(1-0.55*sqr(x));
end;


{======== 12: sin(x)+1/8*pow(sqrtabs(x-z),3) ==========}

function fa12(xx : interval; r:real):analyticd; 
var x : analyticd;
begin
   x := construct(xx, r);
   na:=na+1;
   fa12:= sqrtabs(x);
end; 
     
function fb12(xx : interval):b_interval; 
var x : b_interval;
begin
   nb:=nb+1;
   x := construct(xx);
   fb12:=sqrtabs(x);
end; 
   
function f12(x : interval): interval; 
begin
   f12 := sqrtabs(x);
end;


{======== Aufruf der Integration ================}


begin
   writeln('function number ?');
   read(nr);
   pi:=4*arctan(1);
   n:=0;
   na:=0;
   nb:=0;
   cinte_init;
   case nr of
     0	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f0,fb0,fa0,  0.0, 1.0, 1.0e-12);
	     writeln(integral, diam(integral));
	 end;
     1	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f1,fb1,fa1, 10.0, 40.0, 1.0e-12);
	     writeln(integral, diam(integral));
	 end;
     6	: for i:=1 to 10 do
	 begin
	    integral:= integrate(f6,fb6,fa6, -1.0, 2.0, 1.0e-12);
	     writeln(integral, diam(integral));
	 end;
     7	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f7,fb7,fa7, 0.00001, 1.0, 1.0e-12);
	    writeln(integral, diam(integral));
	 end;
     8	: for i:=1 to 10 do
	 begin
	    integral:= integrate(f8,fb8,fa8, 0.0, 100.0, 1.0e-12);
	    writeln(integral, diam(integral));
	 end;
     9	: for i:=1 to 10 do
	 begin
	    integral:= integrate(f9,fb9,fa9, 0.0, 30.0, 1.0e-12);
	    writeln(integral, diam(integral));
	 end;
     10	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f10,fb10,fa10, 0.0, 7.0, 1.0e-12);
	    writeln(integral, diam(integral));
	 end;
     11	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f11,fb11,fa11, 0.0, 1.0, 0.1e-4,n);
	     writeln(integral, diam(integral));
	    writeln(na,'* fa ,    '  ,nb,'* fb ,    ',n, '* f  aufgerufen');
	        
	 end;
 
     12	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f12,fb12,fa12, 0.0, 4.0, 0.1e-8,n);
	    writeln(integral, diam(integral));
	    writeln(na,'* fa ,    '  ,nb,'* fb ,    ',n, '* f  aufgerufen');
        
	 end;
 
     2	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f2,fb2,fa2, 0.0, 10.0, 1.0e-12, 1.0e-8);
	     writeln(integral, diam(integral));
	 end;
     3	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f3,fb3,fa3, 0.0, 10.0, 1.0e-12);
	     writeln(integral, diam(integral));
	 end;
     4	: for i:=1 to 1 do
	 begin
	    integral:= integrate(f4,fb4,fa4, 0.0, mid(pi), 1.0e-12);
	    writeln(integral, diam(integral));
	 end;
     5	: begin
	     n:=0;
	    for i:=1 to 1000 do
	    begin
	       z:=(i-0.5)/2000;
	       integral:= integrate(f5,fb5,fa5, 0.0, 1.0,1.0e-9, n2);
	       writeln(integral, diam(integral));
	       n:=n+n2;
	    end;
	    writeln('gesamt: ',n,' Stuetzstellen');
	 end;
   end;

end. { test }


      





      
